<script>
    import {browser} from '$app/environment';
    import {onMount} from 'svelte';
    import {Chart, LineController, LineElement, CategoryScale, PointElement, LinearScale, Title} from 'chart.js';
    import utils from "$lib/utils/utils";
    import {Forecast} from "$lib/class/Forecast";
    import ForecastBlock from "../lib/components/ForecastBlock.svelte";
    import img_gitlab from "$lib/assets/gitlab.png";
    import img_email from "$lib/assets/email.png";

    Chart.register(LineController, LineElement, PointElement, CategoryScale, LinearScale, Title);

    export let data;
    let race = data.race;
    let weather = data.weather;
    let serverError = data.error;

    const raceDateTimeString = `${race["date"]}T${race["time"]}`;
    const raceDate = new Date(raceDateTimeString);
    let tooEarly = false;
    let showDayForecast = false;
    let showHoursForecast = false;
    let showMinutesForecast = false;
    let raceIsLive = false;
    let dayForecast, hoursForecast = [];
    let showMoreInfo = false;

    onMount(() => {
        if (serverError) return;
        initDatePrecision();
        if (showMinutesForecast) {
            initChart();
        }
        initRefresher();
    });

    function initDatePrecision() {
        let dateDifference = raceDate - Date.now();

        const minutePrecisionThreshold = 60 * 15 * 1000; //15 minutes
        const hourPrecisionThreshold = 48 * 60 * 60 * 1000; // 2 days
        const dayPrecisionThreshold = 8 * 24 * 60 * 60 * 1000; // 8 days
        const canMinutesForecast = dateDifference < minutePrecisionThreshold;
        const canHoursForecast = dateDifference < hourPrecisionThreshold;
        const canDayForecast = dateDifference < dayPrecisionThreshold;

        tooEarly = !canDayForecast;

        showMinutesForecast = canMinutesForecast;
        showHoursForecast = canHoursForecast;
        showDayForecast = canDayForecast && !canHoursForecast;

        raceIsLive = dateDifference < 0;

        if (showDayForecast) {
            let index = raceIsLive ? 0 : Math.floor(dateDifference / (86400000));
            if (weather["daily"][index]) {
                dayForecast = new Forecast(weather["daily"][index]);
            }
        }

        if (showHoursForecast) {
            let index = raceIsLive ? 0 : Math.ceil(dateDifference / (1000 * 60 * 60));
            for (let i = 0; i < 2; i++) {
                if (weather["hourly"][index + i]) {
                    hoursForecast.push(new Forecast(weather["hourly"][index + i]));
                }
            }
        }

        console.log("day forecast : ", dayForecast);
        console.log("hours forecast : ", hoursForecast);
    }

    let chartElement;

    function initChart() {
        if (!browser) return;
        let weatherData = weather["minutely"];

        let labels = weatherData.map((item) => new Date(item["dt"] * 1000));
        let data = weatherData.map((item) => item["precipitation"]);

        new Chart(chartElement, {
            type: 'line',
            data: {
                labels: labels,
                datasets: [{
                    data: data,
                    borderColor: '#949ecd',
                    borderWidth: 3,
                    pointRadius: 0,
                }]
            },
            options: {
                scales: {
                    x: {
                        grid: {
                            display: false,
                        },
                        ticks: {
                            autoSkip: false,
                            callback: function (value, index, values) {
                                if (this.getLabelForValue(value).getMinutes() % 10 === 0) {
                                    return utils.dateToHours(this.getLabelForValue(value));
                                } else {
                                    return '';
                                }
                            },
                        }
                    },
                    y: {
                        suggestedMax: 10,
                        min: 0,
                        title: {
                            display: true,
                            text: 'Precipitation (mm)'
                        },
                    }
                }
            }
        })
        ;
    }

    function toggleShowMoreInfo() {
        showMoreInfo = !showMoreInfo;
    }

    function initRefresher() {
        let lastActiveTime = new Date();

        function refreshPageIfTabActive() {
            if (!document.hidden) {
                let currentTime = new Date();
                let elapsedTime = currentTime - lastActiveTime;
                let refreshDelayThreshold = 60 * 60 * 1000;
                if (elapsedTime >= refreshDelayThreshold) {
                    location.reload();
                }
            }
        }

        document.addEventListener("visibilitychange", refreshPageIfTabActive);
    }


</script>

<div>
    <div class="main-container">
        <div class="content">
            {#if raceIsLive }
                <p class="title-date live"><span class="live-circle"></span>&nbsp;Live</p>
            {:else }
                <p class="title-date">{raceDate.toLocaleDateString()} - {utils.dateToHours(raceDate) }</p>
            {/if}
            <h1 class="title">{race['raceName']}</h1>
            <p class="title-circuit">{race['Circuit']['circuitName']}</p>
            {#if serverError }
                <p class="server-error">An error has occurred</p>
            {/if}
            {#if tooEarly }
                <p>No forecast data available yet, come back later !</p>
            {/if}
            <div class="forecast-info">
                {#if showDayForecast }
                    <ForecastBlock forecast="{dayForecast}" date="Daily forecast"/>
                {/if}
                {#if showHoursForecast }
                    {#each hoursForecast as forecast}
                        <ForecastBlock forecast="{forecast}" date="{forecast.formattedHours}"/>
                    {/each}
                {/if}
                <div class="chart-container" style="display: {showMinutesForecast ? 'block': 'none'}">
                    <canvas bind:this={chartElement}></canvas>
                </div>
            </div>
            <div class="app-description">
                <button class="btn-unstyle" on:click={toggleShowMoreInfo}>
                    <h2 class="app-description-title">More info</h2>
                </button>
                {#if showMoreInfo }
                    <div>
                        <p>
                            The forecast accuracy improve as we are close to the race :<br>
                            &lt 8 days : daily forecast<br>
                            &lt 2 days : hourly forecast<br>
                            &lt 15 minutes : minutely forecast<br>
                        </p>
                        <div class="credits">
                            <a target="_blank" href="https://gitlab.com/steven.clain27/will-it-rain-f1"><img
                                    src="{img_gitlab}"
                                    alt="gitlab"></a><br>
                            <a href="mailto:steven.clain27@gmail.com"><img src="{img_email}" alt="email"></a>
                        </div>
                    </div>
                {/if}
            </div>
        </div>

    </div>

</div>

<style global>
    .main-container {
        display: flex;
        align-items: center;
        justify-content: center;
        height: 100vh;
    }

    .content {
        width: 100%;
        max-width: 500px;
        padding: 10px 20px;
        background: white;
    }

    @media (max-width: 768px) {
        .content {
            margin-top: -50px;
        }
    }

    .title {
        text-align: center;
        margin: 5px 0;
        font-size: 24px;
    }

    .title-circuit {
        text-align: center;
        font-size: 14px;
    }

    .title-date {
        text-align: center;
        font-size: 16px;
    }

    .title-date.live {
        color: #fb2e0b;
        font-weight: bold;
    }

    .live-circle {
        height: 12px;
        width: 12px;
        background-color: #fb2e0b;
        border-radius: 50%;
        display: inline-block;
    }

    .forecast-info {
        margin: 20px 0;
    }

    .app-description-title {
        font-size: 14px;
        font-weight: normal;
        margin-bottom: 5px;
        margin-top: 5px;
        text-decoration: underline;
    }

    .chart-container {
        margin-top: 20px;
    }

    .credits {
        display: flex;
        gap: 5px;
        justify-content: flex-end;
        margin-top: 10px;
    }

    .credits img {
        width: 20px;
    }

    .server-error {
        color: red;
        margin: 20px 0;
    }
</style>
